       IDENTIFICATION DIVISION.
       PROGRAM-ID.    PRIMER.

      ************************************************************
      * PRIMER EJEMPLO, RECIBE DATOS DE UNA FORMA                *
      * Y LOS MUESTRA EN EL RESULTADO                            *
      ************************************************************

       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SOURCE-COMPUTER.       IBM.
       OBJECT-COMPUTER.       IBM.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.

           COPY "CGILIB\CGI-OUT.SEL".

       DATA DIVISION.

       FILE SECTION.

       COPY "CGILIB\CGI-OUT.FD".


       WORKING-STORAGE SECTION.

       COPY "CGILIB\TEMPLATE.WSS".

      *<COBHTTPD-DATA PREFIX="LS-">
       01  WEB-DATA.
           02  FUNC                  PIC X(10).
           02  CLAVE                 PIC X(10).
           02  NOMBRE                PIC X(50).
           02  DIRECCION             PIC X(50).
           02  IMPORTE               PIC 9(12)V99-.

       01  LIN-FUNC.
           02  FILLER                PIC X(20) VALUE
               "EL VALOR DE FUNC = ".
           02  WS-FUNC               PIC X(20).
           02 FILLER                 PIC X(04) VALUE "<BR>".

       01  LIN-CLAVE.
           02  FILLER                PIC X(20) VALUE
               "EL VALOR DE CLAVE = ".
           02  WS-CLAVE              PIC X(10).
           02 FILLER                 PIC X(04) VALUE "<BR>".

       01  LIN-NOMBRE.
           02  FILLER                PIC X(25) VALUE
               "EL VALOR DE NOMBRE = ".
           02  WS-NOMBRE             PIC X(50).
           02 FILLER                 PIC X(04) VALUE "<BR>".

       01  LIN-DIRECCION.
           02  FILLER                PIC X(25) VALUE
               "EL VALOR DE DIRECCION = ".
           02  WS-DIRECCION          PIC X(50).
           02 FILLER                 PIC X(04) VALUE "<BR>".

       01  LIN-IMPORTE.
           02  FILLER                PIC X(25) VALUE
               "EL VALOR DE IMPORTE = ".
           02  WS-IMPORTE            PIC ZZZ,ZZZ,ZZ9.99-.
           02 FILLER                 PIC X(04) VALUE "<BR>".

       LINKAGE SECTION.

       COPY "CGILIB\LS-HTTP.FDT".

       PROCEDURE DIVISION USING HTTP-CONTROL HTTP-DATA-INP.
       DECLARATIVES.
       BLOQUEO SECTION.
           USE AFTER STANDARD ERROR PROCEDURE ON CGI-OUT.
       END DECLARATIVES.
       PROGRAMA SECTION.
       0000-START.
           display "entro".
           MOVE HTTP-DATA-INP  TO WEB-DATA.

           PERFORM TPL-OPEN-FILE.
           
           IF FUNC = "FORMA"
              PERFORM 100-SHOW-FORMA.
              
           IF FUNC = "GRABAR"
              PERFORM 200-GRABAR.


           CLOSE CGI-OUT.

           GO TO 999-EXIT.
           
       100-SHOW-FORMA.
           MOVE "tpl\primer.html" TO TPL-FILENAME.
           PERFORM TPL-ADD-FILENAME.
       
      * MUESTRA LOS DATOS QUE RECIBIO EL PROGRAMA
      * CON ESTOS DATOS PODEMOS HACER LO QUE DESEEMOS, GRABARLOS
      * EN UN ARCHIVO, VALIDAR, ETC.
      * INCLUSO PODEMOS ENVIARLOS A OTRO TEMPLATE
       200-GRABAR.
           MOVE FUNC TO WS-FUNC.
           MOVE CLAVE TO WS-CLAVE.
           MOVE NOMBRE TO WS-NOMBRE.
           MOVE DIRECCION TO WS-DIRECCION.
           MOVE IMPORTE   TO WS-IMPORTE.

           WRITE R-CGI-OUT FROM LIN-FUNC.
           WRITE R-CGI-OUT FROM LIN-CLAVE.
           WRITE R-CGI-OUT FROM LIN-NOMBRE.
           WRITE R-CGI-OUT FROM LIN-DIRECCION.
           WRITE R-CGI-OUT FROM LIN-IMPORTE.


       COPY "CGILIB\TEMPLATE.FDT".

       999-EXIT.

       EXIT-PROG.
           EXIT PROGRAM.

       END PROGRAM.

